hdu 3367 Pseudoforest (最小生成树)

Pseudoforest


Time Limit: 10000/5000 MS
(Java/Others)    Memory Limit: 65536/65536 K
(Java/Others)
Total Submission(s): 1526    Accepted
Submission(s): 580

Problem Description

In graph theory, a pseudoforest is an undirected
graph in which every connected component has at most one cycle. The maximal
pseudoforests of G are the pseudoforest subgraphs of G that are not contained
within any larger pseudoforest of G. A pesudoforest is larger than another if
and only if the total value of the edges is greater than another
one’s.

Input

The input consists of multiple test cases. The first
line of each test case contains two integers, n(0 < n <= 10000), m(0 <=
m <= 100000), which are the number of the vertexes and the number of the
edges. The next m lines, each line consists of three integers, u, v, c, which
means there is an edge with value c (0 < c <= 10000) between u and v. You
can assume that there are no loop and no multiple edges.
The last test case
is followed by a line containing two zeros, which means the end of the
input.

Output

Output the sum of the value of the edges of the
maximum pesudoforest.

Sample Input

3 3

0 1 1

1 2 1

2 0 1

4 5

0 1 1

1 2 1

2 3 1

3 0 1

0 2 2

0 0

Sample Output

3

5

Source

“光庭杯”第五届华中北区程序设计邀请赛
暨 WHU第八届程序设计竞赛

Recommend

lcy   |   We have
carefully selected several similar problems for you:  3362 3368 3364 3365 3369

伪森林:

题意为有一个伪森林,即森林里的每棵树最多有一个环。

这题还算是不错的,最小生成树小变形,要用kruskal算法,边的排序要按值大到小排。

排完序后就可以按kruskal的做法做了,不过要多作一个circle[]数组来记录每棵树环的情况,如果该树有一个环了就不能再加环,并且如果一条边有两个点一个属于有环树,一个不属于有环树,那么并查集并的时候要讲第二个点并到第一个点中,这样可以避免多个环的情况。思路清晰后还是挺简单的。


 1 //546MS    1464K    1096 B    G++
2 #include<stdio.h>
3 #include<string.h>
4 #include<stdlib.h>
5 #define N 10005
6 struct node{
7 int u,v,d;
8 }p[10*N];
9 int set[N];
10 int circle[N];
11 int n,m;
12 int cmp(const void*a,const void*b)
13 {
14 return (*(node*)b).d-(*(node*)a).d;
15 }
16 int find(int x)
17 {
18 if(set[x]!=x) set[x]=find(set[x]);
19 return set[x];
20 }
21 int kruskal()
22 {
23 int ans=0;
24 for(int i=0;i<m;i++){
25 int tu=find(p[i].u);
26 int tv=find(p[i].v);
27 if(tu==tv){
28 if(!circle[tu]){
29 circle[tu]=1;
30 ans+=p[i].d;
31 }
32 continue;
33 }
34 if(circle[tu] && circle[tv]) continue;
35 if(circle[tu]) set[tv]=tu;
36 else set[tu]=tv;
37 ans+=p[i].d;
38 }
39 return ans;
40 }
41 int main(void)
42 {
43 while(scanf("%d%d",&n,&m)!=EOF&&(n+m))
44 {
45 for(int i=0;i<=n;i++) set[i]=i;
46 memset(circle,0,sizeof(circle));
47 for(int i=0;i<m;i++){
48 scanf("%d%d%d",&p[i].u,&p[i].v,&p[i].d);
49 }
50 qsort(p,m,sizeof(p[0]),cmp);
51 printf("%d\n",kruskal());
52 }
53 }

hdu 3367 Pseudoforest (最小生成树)

时间: 2024-08-10 12:19:56

hdu 3367 Pseudoforest (最小生成树)的相关文章

HDU 3367 Pseudoforest(伪森林)(并查集)

题目连接:http://acm.hdu.edu.cn/showproblem.php?pid=3367 题意:在图论中,如果一个森林中有很多连通分量,并且每个连通分量中至多有一个环,那么这个森林就称为伪森林. 现在给出一个森林,求森林包含的最大的伪森林,其大小通过所有边的权值之和来比较. 分析: 1.一开始想的是:在每个连通分量中求一个最大生成树,然后加一条最大的边,再把每个连通分量算出来的值加起来,但WA了.这并不是最优的,因为还存在这种情况:一个连通分量里最初有两个环,但是伪森林要求最多一个

HDU 3367 Pseudoforest 最大生成树

题目来源:HDU 3367 Pseudoforest 题意:每个连通块最多可以有一个环 求最大的森林 思路:考虑最大生成树 如果祖先一样没有环 那就合并 如果祖先不一样 如果2棵树都没有环 合并 如果有1棵树有环 合并 标记该棵树有环 #include <cstdio> #include <cstring> #include <algorithm> using namespace std; const int maxn = 100010; struct edge { i

hdu 3367 Pseudoforest(并查集)

题意:求图的一最大联通子图,其中最多包含一个环. 思路:利用求最小生成树的方法(kruskal),排序时从大到小排序.连接时有三种情况: 1.一边有环,一边没有(可能两点已经在同一集合,也可能不在) 2.两边都没有环 3.两边都有环 如图: 1 #include<iostream> 2 #include<cstdio> 3 #include<cstdlib> 4 #include<cstring> 5 #include<string> 6 #in

hdu 3367 Pseudoforest【伪森林】

Pseudoforest Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others) Total Submission(s): 1929    Accepted Submission(s): 745 Problem Description In graph theory, a pseudoforest is an undirected graph in which every conne

HDU 3367 Pseudoforest

https://vjudge.net/problem/HDU-3367 题意: 一个伪森林是一个每个连通分量至多有一个环的无向图,给出一个图,图中不包含重边和圈,请你求出这个图的权值最大的伪森林. 思路: 一开始想的是用最大生成树,然后加一条最大的不在生成树中的边,wa了,真是可笑题意都没有理解清楚.题中的图可以是非连通的. 之后看了题解,发现是用并查集的思路,先把边从大到小进行排序,之后对于每一条边,我们看它的两个点a,b. 有2大的种情况: 1.a,b在一个连通分量中,并且他们没有被标记,则

hdu 3367 Pseudoforest 最大生成树★

1 #include <cstdio> 2 #include <cstring> 3 #include <vector> 4 #include <algorithm> 5 using namespace std; 6 7 const int maxn = 100005; 8 int n, m; 9 struct node 10 { 11 int u, v, c; 12 }g[maxn]; 13 long long ans; 14 int fa[maxn];

【HDOJ】3367 Pseudoforest

并查集. 1 #include <cstdio> 2 #include <cstring> 3 #include <cstdlib> 4 5 #define MAXN 10005 6 #define INF 0xffffff 7 8 typedef struct { 9 int c, s, e; 10 } edge_st; 11 12 edge_st edges[100005]; 13 int pre[MAXN]; 14 int deg[MAXN]; 15 int n,

hdu 2686 Matrix &amp;&amp; hdu 3367 Matrix Again (最大费用最大流)

Matrix Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 1394    Accepted Submission(s): 758 Problem Description Yifenfei very like play a number game in the n*n Matrix. A positive integer number

HDU 3367 Hotel

参照这个博客的做法:请戳 ,还有这个的讲解: 询问区间中满足条件的连续最长区间通常属于区间合并问题. 节点增加4个域,lx:从区间左边数连续空房间的数目.rx:从区间右边数连续空房间的数目.ax:该区间中连续空房间的总数目 col:记录该区间住人的状态,1表示全住满,0表示全空,-1表示有可以住的房间. 查询是否有连续空房间数目num的时候,先查询左边,当tree[v].lx >= num的时候递归左区间:再查询中间,当tree[v*2].lx +tree[v*2+1].rx >= num直接